/****************************************************************
 * ItalkServer.h : Italk-Server status class
 *
 * (c) 1997 Yutaka Oiwa.
 *
 * $Id: ItalkServer.h,v 1.4 1998/01/03 20:47:27 yutaka Exp $
 ****************************************************************/

#ifndef _ITALK_SERVER_H
#define _ITALK_SERVER_H

#include "Defines.h"
#include "Monkey.h"

const int MAX_MONKEY = 30;

typedef void (*ItalkServer_callback_t)(int, void *);
class ItalkServer 
{
private:
  // Monkey DATA
  char *name;
  int port;
  char *fullname;

  char *message[2];
  int mes_urgent[2];
  Monkey *monkeys[2][MAX_MONKEY];
  int n_monkeys[2];
  int add_to;

  ItalkServer_callback_t callback;
  void *app_data;

public:
  ItalkServer(const char *name_, int port_, const char *fullname_,
	      ItalkServer_callback_t callback_, void *app_data_);
  void AddMessage(const char *p, int urgent = 0);
  void DeleteMessage();
  const char *GetMessage() const{return message[!add_to];}
  void AddMonkey(Monkey *p);
  void DataFinished();
  const Monkey *const * GetMonkeys() const;
  int Get_NumMonkeys() const {return n_monkeys[!add_to];}
  const char *Get_Name() const {return name;}
  const char *Get_FullName() const {return fullname;}
};
#endif
